﻿using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PasswordFieldXamDataGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.xamDataGrid1.DataSource = GetData().DefaultView;     
        }

        private DataTable GetData()
        {
            string[] names = { "Peter", "Maria", "John", "Vladimir", "Gustavo" };
           

            DataTable dt = new DataTable();

            var keys = new DataColumn[1];

            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("Name", typeof(string));           
            dt.Columns.Add("Date", typeof(DateTime));
            dt.Columns.Add("Password", typeof(string));

            for (int i = 0; i < 10; i++)
            {
                var row = dt.Rows.Add();
                row[0] = i + 1;
                row[1] = names[i % 5];                
                row[2] = DateTime.Now.AddDays(i * 2);
                row[3] = "123456789";
            }
            keys[0] = dt.Columns["ID"];

            dt.PrimaryKey = keys;

            return dt;
        }
    }

    public class TextToPasswordConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            ValueEditor editor = parameter as ValueEditor;
            DataRecord record = editor.DataContext as DataRecord;
            var password = record.Cells["Password"].Value;
            

            var dataGrid = (XamDataGrid)Infragistics.Windows.Utilities.GetAncestorFromType(editor, typeof(XamDataGrid), false);

            string passValue = "";
            for (int i = 0; i < password.ToString().Length; i++)
            {
                passValue = passValue + "*";
            }


            return passValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }
}
